import * as tslib_1 from "tslib";
import React from 'react';
import { FlatList, RefreshControl, StyleSheet, Text } from 'react-native';
import { List } from 'react-native-elements';
var ListView = /** @class */ (function (_super) {
    tslib_1.__extends(ListView, _super);
    function ListView(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            refreshing: false
        };
        return _this;
    }
    ListView.prototype.render = function () {
        var _this = this;
        var _a = this.props, containerStyle = _a.containerStyle, key = _a.key, data = _a.data, renderItem = _a.renderItem, onRefresh = _a.onRefresh, title = _a.title;
        return (<List containerStyle={[styles.container, containerStyle]}>
        {title && (<Text style={{ marginHorizontal: 20, marginTop: 10, fontSize: 18 }}>
            {title}
          </Text>)}
        <FlatList data={data} renderItem={function (_a) {
            var item = _a.item;
            return renderItem(item);
        }} keyExtractor={function (item, index) {
            return key ? item[key].toString() : index.toString();
        }} refreshControl={onRefresh ? (<RefreshControl refreshing={this.state.refreshing} onRefresh={function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.setState({ refreshing: true });
                        return [4 /*yield*/, onRefresh()];
                    case 1:
                        _a.sent();
                        this.setState({ refreshing: false });
                        return [2 /*return*/];
                }
            });
        }); }}/>) : (undefined)}/>
      </List>);
    };
    return ListView;
}(React.Component));
export { ListView };
var styles = StyleSheet.create({
    container: { flex: 1, marginTop: 0 }
});
//# sourceMappingURL=ListView.js.map